import ij.*;
import ij.process.*;
import ij.io.*;
import ij.gui.*;
import java.awt.*;
import ij.plugin.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import java.util.Vector;
import java.lang.Number;
import javax.swing.*;
import javax.swing.WindowConstants.*;
import javax.swing.event.*;
import java.lang.Math.*;

import scion.fg.*;
import scion.fg.capture.*;
import scion.cd.*;
import scion.util.*;
import scion.ij.*;

import Serialio.*;

public class Acquire_4D implements PlugIn,WindowConstants,export_listener,KeyListener{
public boolean stopProgram = false;
//public JProgressBar progress;
	private static String[] choices = {"Tiff", "8-bit Tiff", "Jpeg", "Zip", "Raw"};
	private static String format = "Tiff";
public JFrame myFrame;
public JLabel myLabel1,myLabel2,myLabel3,myOtherLabel;
public ImagePlus myImp, tempImp;
public ImageProcessor ip;
public String myPath;
public String rootName, infoString;
//private int max = 30;
private int j = 0;
public long startTime, currentTime;
public int focalPlanes = 1;
public int timePoints = 1;
public double spacing = 1;
public int shutters = 1;
public double manualStepSize = 1;
public long delayTime = 60000;//in msec
public fg_manager     fgm,lgm;
public SerialConfig serCfg,serCfg2;
public SerialPortLocal p,p2;
public int shutterDelay = 30;//0.03 sec
public int focusDelay = 200;//0.1 sec

public Previewer myPreviewer;

public boolean liveCaptureShowing = false;


public void run(String arg) {
double tInitial = 60;
double fInitial = 1;
double dInitial = 1;
double pInitial = 1;
boolean uInitial = true;
String sInitial = "file";
String infoInitial = "";
//myImp = WindowManager.getCurrentImage(); //for testing using existing image
		GenericDialog gd = new GenericDialog("4D Acquisition", IJ.getInstance());
                	gd.addNumericField("Time interval (sec):",tInitial, 1);
		gd.addNumericField("Time points:",pInitial, 0);
		gd.addNumericField("Focal planes:", fInitial,0);
		gd.addNumericField("Spacing (m):", dInitial,1);
		gd.addCheckbox("Use shutter",uInitial);
        		gd.addStringField("Root name for files: ",sInitial);
        		gd.addStringField("Info: ",infoInitial);
		gd.addChoice("File format: ", choices, format);
		gd.showDialog();
		if (gd.wasCanceled())
			return;
		format = gd.getNextChoice();
    delayTime = 1000 * (long) gd.getNextNumber();
	timePoints = (int) gd.getNextNumber();
    focalPlanes =   (int) gd.getNextNumber();
spacing = gd.getNextNumber();
//shutters = (int) gd.getNextNumber();
if (gd.getNextBoolean()) {shutters = 1;} else {shutters = 0;}
     rootName = gd.getNextString();
       infoString = gd.getNextString();
       GenericDialog rd = new GenericDialog("Review 4D Parameters",IJ.getInstance());
       rd.addMessage("Time interval (sec): " + delayTime/1000 + "\n" + "Time points: " + timePoints + "\n" + "Focal planes: " + focalPlanes + "\n" + "Spacing (m): " + spacing + "\n" + "Shutters: " + shutters + "\n" + "Root name: " + rootName + "\n" + "Info: " + infoString + "\n" + "File format: " + format);
       rd.showDialog();
       if (rd.wasCanceled()) {return;}
       myPath="";//temp to bypass save routine
setUpSerialPort();
 makePanel();
if (shutters == 1) {openShutter();}
IJ.wait(shutterDelay);
	IJ.run("Capture Grayscale");

//closeShutter();
	myImp = WindowManager.getCurrentImage();
         WindowManager.getCurrentWindow().setTitle(rootName + 1 + ".tif");
       save(myImp,format,myPath,rootName,0); 
       //save info file for 4d sequence
       writeInfoFile(myPath+rootName+".txt");
        for (int i=0; i<timePoints; i++) {
        if (stopProgram) {
				if (myPreviewer != null) {
				myPreviewer.stop_Preview();
				myPreviewer.live_win.dispose();
				}
				shutDownShutter(); 
				 break;
				}
        startTime = System.currentTimeMillis();
        j = i + 1;  
//IJ.log("Time:" + j);
	if (shutters == 1) {openShutter();IJ.wait(shutterDelay);}
	//double positionCounter = 0;
       for (int k=0; k< focalPlanes; k++){
//if (k == 0) {positionCounter = 0;}
       	myOtherLabel.setText("Capturing focal plane " + (k + 1) + "/" + focalPlanes);
	//IJ.run("Capture Grayscale file");
	startScion();
	save(tempImp,format,myPath,rootName,i*focalPlanes + k + 1);myImp.setProcessor("Focal plane " + (k+1) + "/" + focalPlanes,ip);myImp.updateAndDraw();
	 {
	moveFocus(spacing);
	//positionCounter = positionCounter + spacing;
	//IJ.log("Position:" + positionCounter);
	}
	//give focus motor some time!
	IJ.wait(focusDelay);
	//IJ.showStatus("Focal plane " + (k+1) + "/" + focalPlanes);
	}
	if (shutters == 1)  {closeShutter();}
	double totalMove = -1*focalPlanes* spacing;
	moveFocus(totalMove);
	//IJ.log("Moving back:" +totalMove);
	if ((myPreviewer != null) && (myPreviewer.capturing)) {if (shutters == 1) {openShutter();} myPreviewer.start_Preview();}
	//IJ.showStatus("Captured time point " + j + ". Waiting for next time point...");
       // save(myImp,format,myPath,rootName,j); 
        if ((j == 1) && (myPath == null)) {break;} else if (j == 1) {startTime = System.currentTimeMillis();}
        if (j != timePoints){
        currentTime = System.currentTimeMillis() - startTime;
        long oldTime = 0;
        while (currentTime < delayTime){
        if (stopProgram) break;
            currentTime = System.currentTimeMillis() - startTime;
            //shut down capture 2 sec before Z series acquisition
            if (((delayTime - currentTime) < 2000) && (myPreviewer != null) && (myPreviewer.capturing)) {myPreviewer.stop_Preview();}
            if ((currentTime - oldTime) > 1000) {
            myLabel1.setText("Time points captured: " + j);
		myLabel2.setText("Remaining: " + (timePoints -j));
		myLabel3.setText("Time until next (sec): " + java.lang.Math.round ((int) ((delayTime - currentTime)/1000)));
             oldTime = currentTime;
                }//if a second has elapsed
             }//while
            }//if j < timePoints
          }//for loop
	if (myPreviewer != null) {if (myPreviewer.live_win != null) {myPreviewer.live_win.dispose();} }
	myFrame.dispose();if ((shutters == 1) && !stopProgram) {closeShutter();}
	shutDownShutter();//actually shuts down serial port for use by other programs or another movie
	}//run
    
    void makePanel(){
    //make window for display progress and cancel button

        //progress = new JProgressBar();
	JButton         button = new JButton();
	JButton         openButton = new JButton();
	JButton         closeButton = new JButton();
	JButton 	liveCapture = new JButton();
	JButton    stopCapture = new JButton();
	JButton upButton = new JButton();
	JButton downButton = new JButton();

        JPanel          topPanel = new JPanel();

               myFrame = new JFrame("4D Capture");
               myFrame.setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
      
      
		myFrame.setSize( 220, 250);
		//setBackground( Color.gray );

		topPanel = new JPanel();
		topPanel.setPreferredSize( new Dimension( 200, 300 ) );
		myFrame.getContentPane().add( topPanel );

		// Create a label and progress bar
		myLabel1 = new JLabel( "" );
		myLabel1.setText("Time points captured: " + 0);
		myLabel2 = new JLabel( "" );
		myLabel2.setText("Remaining: " + (timePoints));
		myLabel3 = new JLabel( "" );
		myLabel3.setText("Time until next (sec): " + java.lang.Math.round ((int) ((delayTime - currentTime)/1000)));
		//myLabel.setPreferredSize( new Dimension( 300, 100) );
             myLabel1.setForeground(Color.black);
		myLabel2.setForeground(Color.black);
		myLabel3.setForeground(Color.black);
		topPanel.add( myLabel1);
		topPanel.add( myLabel2);	
		topPanel.add( myLabel3);
		myOtherLabel = new JLabel( "Capturing focal plane:" );
		//myOtherLabel.setPreferredSize( new Dimension( 300, 50) );
             myOtherLabel.setForeground(Color.black);
		topPanel.add( myOtherLabel );


		button = new JButton( "            Stop Capture            " );
		 button.setForeground(Color.red);
		topPanel.add( button );
		button.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                    stopProgram = true;
                    myFrame.dispose();
                    }
                    });

		openButton = new JButton( "Open shutter" );
		//topPanel.add( openButton );
		openButton.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                    openShutter();
                    }
                    });

		closeButton = new JButton( "Close shutter" );
		//topPanel.add( closeButton );
		closeButton.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                    closeShutter();
                    }
                    });

		liveCapture = new JButton( "            Live preview            " );
		topPanel.add( liveCapture );
		liveCapture.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
		//check for preexisting Live Preview window; if there is one, don't do call to doLivePreview
//below works on Java 1.2 and above, but not 1.1.8, so Mac OS 9 is out of luck!!
/*
		Frame[] myFrames = Frame.getFrames();
                        boolean viewerOpen = false;
                        for (int i=0; i<myFrames.length; i++){
                       if ("Scion Live Video" == myFrames[i].getTitle()) viewerOpen = true;
			}
		if (! viewerOpen) doLivePreview();
**/
		//below doesn't work either under OS 9!
                   //  if (ij.WindowManager.getFrame("Scion Live Video") != null){IJ.beep();} else {doLivePreview();}
                   if (myPreviewer == null) {doLivePreview();openShutter();myFrame.toFront();} else if (myPreviewer.live_win != null){
                  // myPreviewer.live_win.setVisible(true);
                  myPreviewer.recreateWindow();
                   if (shutters == 1) {openShutter();}
                   myPreviewer.start_Preview();myFrame.toFront();
                   } else {IJ.showMessage("Live Window was closed.");}
                   }//actionperformed
                                       });
                    
		stopCapture = new JButton( "            Stop preview            " );
		topPanel.add(stopCapture);
		stopCapture.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                     if ((myPreviewer != null) && (myPreviewer.live_win != null)) { myPreviewer.stop_Preview();myPreviewer.capturing = false;
                     //myPreviewer.live_win.setVisible(false);
                     if (shutters == 1) {closeShutter();}
                     }
                    }
                    });
                    
                    downButton = new JButton( "Down" );
		downButton.setForeground(Color.blue);
		topPanel.add( downButton );
		downButton.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                   moveFocus((double) -1 * manualStepSize); 
                    }
                    });

                   upButton = new JButton( "Up" );
		 upButton.setForeground(Color.blue);
		topPanel.add( upButton );
		upButton.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                    moveFocus((double) 1 * manualStepSize); 
                    }
                    });

	myFrame.addKeyListener(this);
      myFrame.show();
    }
    
    	public void keyPressed(KeyEvent e) {
     //IJ.showStatus("Key " + e.getKeyCode());
     	int flags = e.getModifiers();
		//IJ.showStatus("keyCode=" + e.getKeyCode() + "(" + flags + ")");
		// Shift = 1, Ctrl = 2, Cmd = 4, Opt = 8

		switch (e.getKeyCode()) {
				case KeyEvent.VK_UP:
					moveFocus((double) 1 * manualStepSize); 
					break;
				case KeyEvent.VK_DOWN:
					moveFocus((double) -1 * manualStepSize); 
					break;
				case KeyEvent.VK_LEFT:
					//StepBwd();
					break;
				case KeyEvent.VK_RIGHT:
					//StepFwd();
					break;
				case KeyEvent.VK_SPACE:
					//toggle live preview here!
					
					if (myPreviewer == null) {doLivePreview(); if (shutters == 1) {openShutter();} myFrame.toFront();break;}
									
					 if ((myPreviewer != null) && (myPreviewer.live_win != null) && (myPreviewer.capturing == true)) { 
					 myPreviewer.stop_Preview();myPreviewer.capturing = false;
                     			//myPreviewer.live_win.setVisible(false);
                     			if (shutters == 1) {closeShutter();}
                     			break;
                     			}
                     			
					if ((myPreviewer.live_win != null) && (myPreviewer.capturing == false)){
                  				// myPreviewer.live_win.setVisible(true);
                  				myPreviewer.recreateWindow();
                  				if (shutters == 1) {openShutter();}
                   				myPreviewer.start_Preview();
                   				myFrame.toFront();
                   				break;
					}
															
					break;
				case KeyEvent.VK_ENTER:
					//toggle livepreview
					break;


			}
	}

	public void keyReleased(KeyEvent e) {}
	public void keyTyped(KeyEvent e) {}
	
	void writeInfoFile(String myFile){
	//Writes text file that contains info about the 4d sequence
        
                //write the data to an info file - Line 1 = general info;
                //Line 2 = focal planes; Line 3 = space between focal planes
                //Line 4 = time interval
                
                FileOutputStream out; // declare a file output object
                PrintStream p; // declare a print stream object

                try
                {
                        // Create a new file output stream
                        // connected to "myfile.txt"
                        out = new FileOutputStream(myFile);

                        // Connect print stream to the output stream
                        p = new PrintStream( out );
                        p.println (infoString); p.println(focalPlanes);
                        p.println(spacing); p.println(delayTime/1000);
                        p.close();
                }
                catch (Exception e)
                {
                        System.err.println ("Error writing to file");
                }
                
            }


    
    	public void save(ImagePlus img, String format,String dir,String root,int i ) {
		String name = img.getTitle();
		String padString = "";
		if (i < 10) {padString = "000";} else if (i < 100) { padString = "00";} else if (i < 1000) {padString = "0";}
		String path = dir + root + padString + i;
		if (format.equals("Tiff"))
                    if (i == 0) {SaveDialog sd = new SaveDialog("Open destination folder...", root + padString + (i+1)+ ".tif", "");
                        if (sd.getFileName()==null) {stopProgram = true; return;}
                        myPath = sd.getDirectory();
                        new FileSaver(img).saveAsTiff(myPath + root +  padString + (i+1) +".tif");} 
                    else {new FileSaver(img).saveAsTiff(path+".tif");}
		else if (format.equals("8-bit Tiff"))
                    if (i == 0) {SaveDialog sd = new SaveDialog("Open destination folder...", root + padString + (i+1)+ ".tif", "");
                        if (sd.getFileName()==null) return;
                        myPath = sd.getDirectory();
                        saveAs8bitTiff(img, myPath + root + padString + (i+1) +".tif");} 
                    else {saveAs8bitTiff(img, path+".tif");}
		else if (format.equals("Zip"))
                	if (i == 0) {SaveDialog sd = new SaveDialog("Open destination folder...", root + padString + (i+1)+ ".zip", "");
		if (sd.getFileName()==null) return;
		myPath = sd.getDirectory();
                new FileSaver(img).saveAsZip(myPath + root + padString + (i+1) +".zip");} 
                        else {
			new FileSaver(img).saveAsZip(path+".zip");}
		else if (format.equals("Raw"))
                			if (i == 0) {SaveDialog sd = new SaveDialog("Open destination folder...", root +padString + (i+1) + ".raw", "");
		if (sd.getFileName()==null) return;
		myPath = sd.getDirectory();
                new FileSaver(img).saveAsRaw(myPath + root +padString + (i+1) +".raw");} 
                        else {
			new FileSaver(img).saveAsRaw(path+".raw");}
		else if (format.equals("Jpeg"))
if (i == 0) {SaveDialog sd = new SaveDialog("Open destination folder...", root + padString + (i+1) + ".jpg", "");
		if (sd.getFileName()==null) return;
		myPath = sd.getDirectory();
                new FileSaver(img).saveAsJpeg(myPath + root +padString + (i+1) +".jpg");} 
                        else {
			new FileSaver(img).saveAsJpeg(path+".jpg");}
	}

	void saveAs8bitTiff(ImagePlus img, String path) {
		ImageProcessor ip = img.getProcessor();
		if (ip instanceof ColorProcessor)
			{ip = reduceColors(ip); img.setProcessor(null, ip);}
		else if ((ip instanceof ShortProcessor) || (ip instanceof FloatProcessor))
			{ip = ip.convertToByte(true); img.setProcessor(null, ip);}
		new FileSaver(img).saveAsTiff(path);
	}

	ImageProcessor reduceColors(ImageProcessor ip) {
		MedianCut mc = new MedianCut((int[])ip.getPixels(), ip.getWidth(), ip.getHeight());
		Image img = mc.convert(256);
		return(new ByteProcessor(img));
	}

	void setUpSerialPort (){
		String devName = "KeySerial1";
		//String devName = "Printer Port USB";
		//String devName2 = "Printer Port";
		//SerialConfig serCfg;
		//SerialPortLocal p;
		

		try{
			serCfg = new SerialConfig(devName);
			p = new SerialPortLocal(serCfg);
			if (p.getPortNum() == -1)
			{throw new IOException("USB serial port not initialized");}
			serCfg.setBitRate(SerialConfig.BR_9600);//was 9600
			serCfg.setDataBits(SerialConfig.LN_8BITS);
			serCfg.setStopBits(SerialConfig.ST_2BITS);
			serCfg.setParity(SerialConfig.PY_NONE);
			p.setTimeoutRx(1000);
			p.configure();
			//IJ.log("Modem port initialization:" + "\n" + "Port number: " + p.getPortNum() + " Bit rate: " + p.getBitRate() + " Data: " + p.getDataBits() + "\n" + " Stop: " + p.getStopBits() + " Parity: " + p.getParity());
			p.putString("open s 2" +(char) 13);
			p.txDrain();
			
/*
			serCfg2 = new SerialConfig(devName2);
			p2 = new SerialPortLocal(serCfg2);
			if (p2.getPortNum() == -1)
			{throw new IOException("Printer port not initialized");}
			serCfg2.setBitRate(SerialConfig.BR_9600);
			serCfg2.setDataBits(SerialConfig.LN_8BITS);
			//Prior stage expects 1 stop bit!
			serCfg2.setStopBits(SerialConfig.ST_1BITS);
			serCfg2.setParity(SerialConfig.PY_NONE);
			p2.setTimeoutRx(1000);
			p2.configure();
*/			
		}
		catch(IOException e){
			System.out.println(e);
		}
 	}

		void openShutter(){
			try{
				p.putString("open s 2" +(char) 13);
				//p.putString("A");
				p.txDrain();
			}
			catch(IOException e){
				System.out.println("Open shutter error = " + e);
			}
		}

		void closeShutter(){
			try{
				p.putString("close s 2" +(char) 13);
				//p.putString("@");
				p.txDrain();
			}
			catch(IOException e){
				System.out.println("Close shutter error = " + e);
			}
		}

		void moveFocus(double distance){
			try{
				p.putString("movrel b=" + (int) distance*100 +(char) 13);
				p.txDrain();
			}
			catch(IOException e){
				System.out.println("Move focus error = " + e);
			}
		}

/*
		void moveFocus(double step){
			try{
				//IJ.log("step: " + (int) step);
				//used modem port before with Ludl; current lab setup requires controlling focus via Prior stage through printer port
				//p.putString("movrel b=" + (int) step*100 +(char) 13);
				//p.txDrain();
				if (step > 0) {p2.putString("D" +(char) 13);} else if (step > -2) {p2.putString("U" + (char) 13);}
				if (step < -1) {
				//IJ.log("Resetting focus motor. Step = " + (int) (-1 * step));
												p2.putString("U" +(char) 13);
						}
				//if (step < 0) {IJ.doCommand("Move down");} else {IJ.doCommand("Move down");}
				p2.txDrain();

			}
			catch(IOException e){
				System.out.println(e);
			}
		}
**/

		void shutDownShutter(){
			try{
				if (p.isOpen()) {
				//close shutter
				//closeShutter();
				//p.txDrain(); 
				p.close();}
/*
				if (p2.isOpen()) {
				//p.txDrain(); 
				p2.close();}
**/

			}
			catch(IOException e){
				System.out.println("Shut down shutter error = " + e);
			}
		}

 void startScion(){
   
       // make sure Scion Java Package is installed

    String classPath = System.getProperty("java.class.path");
    if(classPath.indexOf("scion") < 0)
      {
//      scion_alert();
//      return;
      }


    capture_image();            // get image from frame grabber

    return;
    }


  /** Method to capture single image into a new ImagePlus object. */
	private void  capture_image()
		{
    fg_config   config;
    fg_signal   signal;

    jsfg_fg     fg;

    int         cc;

    fgm = new fg_manager(IJ.getInstance());

    if(fgm.openFG() != fgm.success)
      {
      // frame grabber not opened

      return;
      }


		// setup for grayscale capture and get image

    fg = fgm.getFG();
    config = new fg_config(fg, true);         // fg preferences
    signal = new fg_signal(fg);               // signal adjustments
    signal.load();                            // load from preferences


    // change settings to force normal resolution grayscale
    // and use the stored prefs for the rest

    //config.set_image_type(config.gray_image);
    //config.set_channel(1);
   // config.clear_high_res();


    // allocate image - then create a compatible simage object

    jsfg_dimensions image_size;
   // ImageProcessor  ip;
   // ImagePlus       tempImp;
    simage          image;

    try
      {
      image_size = config.get_image_dimensions();
      ip = new ByteProcessor(image_size.get_width(),
                                                image_size.get_height());
      tempImp = new ImagePlus("", ip);

      image = ScionIJTools.createSimage(tempImp);
      }
    catch(OutOfMemoryError e)
      {
      mem_alert();
      fgm.closeFG();
      return;
      }


    // get frame

    fg_capture  co = new fg_capture(fg, config, signal);
    co.setup();
    co.disable_ext_trigger();
    cc = co.capture(image);

    if(cc == co.success)
      {
      // completed successfully

     //imp.show();           // display image in ImageJ window
	//myImp = tempImp;

      }


		// frame grabber is open - close it

    fgm.closeFG();
		}



  /** Method to process no scion java package alert */
  private void scion_alert()
    {
    new InfoDialog(IJ.getInstance(), "Scion Java Alert",
            "Plugin requires the Scion Frame Grabber Java Package\n" +
            "to be installed on your computer.",
            true);
    }

    
  /** Method to process insufficient memory alert. */
  private void mem_alert()
    {
    new InfoDialog(IJ.getInstance(), "Scion Frame Grabber Alert",
            "Insufficient memory to perform image capture.\n \n" +
            "The image capture will not proceed.",
            true);
    }

	void doLivePreview(){
   	// run live preview window and don't return until window killed

    	live_preview();
    	}

/** Method to select frame grabber and display Live Capture Window. This
  method will not return until the Live Capture Window is closed. Since we
  are executing in our own thread, it doesn't really matter that we wait
  here since this thread has nothing else to do!!!!!! */
	private void live_preview()
		{

		// launch live preview

//IJ.doCommand("Live Capture 4D");
   fgm = new fg_manager(IJ.getInstance());

    if(fgm.openFG(false) != fgm.success)
      {
      // frame grabber not opened

      return;
      }


		// launch live pre-view
/**
    fgm.createLiveWin(this);

    LiveWin live_win = fgm.getLiveWin();
    live_win.setTitle("4D Preview");
  // ScionPrefs.putBoolean(LiveWin.tool_bar_key,true);
  // live_win.toFront();
 // live_win.addWindowListener(this);
   live_win.live_command(LiveCommand.lcmd_start);
 // IJ.showMessage("Menus: " + IJ.getInstance().getMenuBar().getMenuCount());
 */

 
 
 // IJ.showMessage("Tool bar: " + live_win.tool_bar_key + "Status bar: " + live_win.status_bar_key + "Scale: " + live_win.scale_key);
//   ij.WindowManager.addWindow(live_win);
  // if (live_win == IJ.getFrontWindow()) { 
  //IJ.showMessage("Front window: " +ij.WindowManager.getFrontWindow().getTitle());
myPreviewer = new Previewer(fgm);

    }

 /** Request from live preview to export image to us. */
  public void export_image(simage image)
    {
    // create an imageplus object and display it

    ImagePlus imp = ScionIJTools.createImagePlus("Camera " +
                                ScionIJTools.getImageNo(), image);
    imp.show();
    }


  /** Method to show About Scion Dialog in text version. */
	void showAbout()
		{
    new InfoDialog(IJ.getInstance(), "About Scion Live Video...",
			"Live Video for Scion PCI Frame Grabbers.\n \n" +
      "This Plugin requires the Scion Frame Grabber Java Package\n" +
      "to be installed on your computer."
			);
		}

class Previewer extends Thread implements export_listener,WindowListener{
public fg_manager myFgm;
public LiveWin live_win;
public boolean capturing = false;

public Previewer(fg_manager fgm){
super();
myFgm = fgm;
    myFgm.createLiveWin(this);
    live_win = myFgm.getLiveWin();
    live_win.setTitle("4D Preview");
   live_win. addWindowListener(this);
  // ScionPrefs.putBoolean(LiveWin.tool_bar_key,true);
  // live_win.toFront();
   live_win.live_command(LiveCommand.lcmd_start);
   capturing = true;
}
public void run(){

doPreview();
}

public void recreateWindow(){
   myFgm.createLiveWin(this);
    live_win = myFgm.getLiveWin();
    live_win.setTitle("4D Preview");
  // ScionPrefs.putBoolean(LiveWin.tool_bar_key,true);
  live_win.setVisible(true);
   //live_win.toFront();
   live_win.live_command(LiveCommand.lcmd_start);
   capturing = true;
   }

public void doPreview(){
start_Preview();
 }

public void stop_Preview(){
live_win.live_command(LiveCommand.lcmd_stop);
}

public void start_Preview(){
live_win.live_command(LiveCommand.lcmd_start);
capturing = true;
}

public void windowClosing(WindowEvent e){
//we simply hide the window rather than disposing of it 
//to avoid squirrely behavior of the Scion live capture
capturing = false;
live_win.setVisible(false);
 }
 
 public void windowOpened(WindowEvent e){
 }

public void windowClosed(WindowEvent e){
//IJ.showMessage("Live capture window closed!");
 }
 
 public void windowIconified(WindowEvent e){
 }
 
 public void windowDeiconified(WindowEvent e){
 }
 
 public void windowActivated(WindowEvent e){
 }
 
 public void windowDeactivated(WindowEvent e){
 }


/** Request from live preview to export image to us. */
  public void export_image(simage image)
    {
    // create an imageplus object and display it

    ImagePlus imp = ScionIJTools.createImagePlus("Camera " +
                                ScionIJTools.getImageNo(), image);
    imp.show();
    }


  /** Method to show About Scion Dialog in text version. */
	void showAbout()
		{
    new InfoDialog(IJ.getInstance(), "About Scion Live Video...",
			"Live Video for Scion PCI Frame Grabbers.\n \n" +
      "This Plugin requires the Scion Frame Grabber Java Package\n" +
      "to be installed on your computer."
			);
		}

}//class Previewer
 

 
    
}

